<script lang="ts">
import Vue from 'vue';
import WordCloud from '../assets/word-cloud.vue';
import GlobeGraphic from '../assets/globe-graphic.vue';
import AnimatedNumber from './animated-number.vue';
import ParallaxContainer from './parallax-container.vue';
import SurveyStatBarsSection from './survey-stat-bars-section.vue';
import StatsGrid from './stats-grid.vue';

export default Vue.extend({
  name: 'ColumnGroup',
  components: {
    WordCloud,
    GlobeGraphic,
    AnimatedNumber,
    ParallaxContainer,
    SurveyStatBarsSection,
    StatsGrid,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <section class="column-group" :class="`column-group--${data.spacing}`">
    <SlpContainer>
      <div
        v-if="data.background"
        class="column-group__background"
        data-aos="zoom-in-up"
        data-aos-duration="600"
      >
        <ParallaxContainer :offset="0.03">
          <nuxt-img
            :src="data.background"
            alt=""
            loading="lazy"
            format="webp"
            quality="99"
          />
        </ParallaxContainer>
      </div>
      <SlpRow :class="`slp-align-items-${data.align} column-group__row`">
        <SlpColumn
          v-for="(column, index) in data.columns"
          :key="index"
          :cols="column.size ?? 6"
          class="column-group__col"
        >
          <div v-for="block in column.blocks" :key="block.title ?? block.text">
            <div v-if="block.graphic?.name" class="column-group__graphic">
              <div>
                <component
                  :is="block.graphic?.name"
                  :data="block.graphic?.data"
                  :asset="block.graphic?.asset"
                />
              </div>
              <div
                v-if="block.stat?.percent"
                class="column-group__stat"
                :data-aos="column.aos_animation"
                :data-aos-duration="column.aos_duration"
                :data-aos-offset="column.aos_offset"
              >
                <SlpTypography
                  v-if="block.stat.title"
                  variant="heading5-bold"
                  tag="p"
                  class="column-group__title slp-mb-8"
                  >{{ block.title }}</SlpTypography
                >
                <AnimatedNumber
                  :number="block.stat.percent"
                  class="column-group__number slp-mb-16"
                />
                <SlpTypography
                  v-if="block.stat.description"
                  variant="body1"
                  tag="p"
                  >{{ block.stat.description }}</SlpTypography
                >
              </div>
            </div>
            <div v-if="block?.stats_bar" class="column-group__stats">
              <SurveyStatBarsSection :data="block.data" />
            </div>
            <div v-if="block?.stats_grid" class="column-group__grid">
              <StatsGrid :data="block.data" />
            </div>
            <div
              v-else
              :data-aos="column.aos_animation"
              :data-aos-duration="column.aos_duration"
              :data-aos-offset="column.aos_offset"
            >
              <SlpTypography
                v-if="block.title"
                class="slp-mb-16 column-group__title"
                tag="div"
                variant="heading4-bold"
              >
                {{ block.title }}
              </SlpTypography>
              <SlpTypography
                v-if="block.text"
                :tag="block.tag ?? 'div'"
                :variant="block.typography ?? 'heading5-bold'"
              >
                <div v-html="block.text"></div>
              </SlpTypography>
              <SlpButton
                v-if="block.button"
                class="column-group__button slp-mt-24"
                variant="primary"
                :data-ga-name="
                  block.button?.data_ga_name ?? 'start your free trial'
                "
                :data-ga-location="block.button?.data_ga_location ?? 'header'"
                :href="block.button?.href ?? '/free-trial/'"
                >{{ block.button?.text }}
                <SlpIcon
                  v-if="block.button?.icon"
                  :name="block.button?.icon.name"
                  :variant="block.button?.icon.variant ?? 'marketing'"
                  class="slp-ml-8"
                />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.column-group {
  color: $color-primary-300;
  position: relative;
  &--large {
    padding-top: 0;
    @media (min-width: $breakpoint-md) {
      padding-top: $spacing-160;
    }
  }
  &--medium {
    padding-top: 0;
    @media (min-width: $breakpoint-md) {
      padding-top: $spacing-64;
    }
  }
  &__row {
    margin-left: -$spacing-64;
  }
  &__col {
    width: 100%;
    padding-left: $spacing-64;
    margin-bottom: $spacing-32;
    &:last-of-type {
      margin-bottom: 0;
    }
    @media (min-width: $breakpoint-md) {
      margin-bottom: 0;
    }
  }
  :deep {
    .slp-col-md-12 {
      margin-bottom: $spacing-64;
      width: 100%;
    }
  }
  &__title {
    color: #5dd7b1;
  }
  &__graphic {
    position: relative;
    :deep .globe-graphic {
      max-width: 350px;
    }
  }
  &__stat {
    position: absolute;
    top: 21%;
    right: 0;
    max-width: 350px;
    left: 0;
    margin: 0 auto;
    text-align: center;
    z-index: 1;
  }
  &__background {
    position: absolute;
    left: 4%;
    bottom: 60%;
    @media (min-width: $breakpoint-md) {
      bottom: 18%;
    }
  }
  &__number :deep * {
    font-size: $spacing-160;
    font-family: 'GitLab Mono';
  }
}
</style>
